//              CS 290-Java Demo 2
//   Loading, Scaling, and Displaying a GIF Image from the Internet
//
//           By Charles W. Neville
//    Copyright 1998 by Charles W. Neville
//
//   Based on many similar programs, for example LoadImageAndScale.java in 
//   Java, How to Program, 2nd ed., by H. M. and P. J. Deitel, Prentice Hall, 
//   1998, or ImagePrototype.java in Java Software Solutions, by John Lewis and 
//   William Loftus, Addison Wesley, 1998

// Java provides a rich collection of classes dealing with Internet 
// communication and image display.  This Applet downloads a Hubble Space 
// Telescope image of the Whirlpool Galaxy from an ftp site and displays it at 
// half size and full size.
//
// Because Java Applets severely restrict the source of downloaded files for 
// security reasons, you may have to turn off some of your Web browser's (or 
// appletviewer's) security features in order to successfully run this Applet.
// Be sure to turn them back on again when you are finished to keep members of
// evil.wicked.hackers.org from trashing your computer.

import java.applet.Applet;
import java.awt.*;
import java.net.*;

public class ImageDisplayApplet extends Applet {

  Image im;
  URL urlBase;

  public void init() {

    // In Java, a URL is more than a string containing a Web address.  A Java 
    // URL object contains a Web address, but it also understands a rich 
    // collection of methods for accessing internet content.

   // try .. catch clause is exception handling stuff -- need it because
   // init() can't throw a MalformedURLException, but the URL constructor
   // does throw such an exception
   try{

      // Construct a base URL
      urlBase = new URL("ftp://cs.ccsu.ctstateu.edu/pub/SPACE/Hubble94/");
   }
   catch(MalformedURLException e) {

    // do nothing if the URL is malformed, because it isn't
   } 

    // Download the image from the ftp site
    im = getImage( urlBase, "wfpc-02.gif" );

    // Note: To get a local image file in the same directory as the applet,
    // one would replace this by something like:

    // im = getImage( getDocumentBase(), "myImage.gif" );    
  }

  public void paint ( Graphics g ) {

    // draw the image with its width and height halved
    int width = im.getWidth(this);
    int height = im.getHeight(this);
    // Remember: Unlike many other languages, Java treats the division 
    // operator as INTEGER DIVISION if both top and bottom are
    // integers.  Thus width/2 returns an INTEGER.
    g.drawImage(im, 1, 1, width/2, height/2, this );

    // then draw the original image
     g.drawImage( im, 1, 200, this);
  }
}

    
